terraform/Makefile

106 lines
3.3 KiB
Makefile
Raw Normal View History

TEST?=./...
GOFMT_FILES?=$$(find . -name '*.go' | grep -v vendor)
2014-05-23 01:56:28 +02:00
2016-02-22 19:35:50 +01:00
default: test vet
2016-06-03 02:27:31 +02:00
tools:
go get -u github.com/kardianos/govendor
go get -u golang.org/x/tools/cmd/stringer
go get -u golang.org/x/tools/cmd/cover
2015-01-27 03:19:22 +01:00
# bin generates the releaseable binaries for Terraform
bin: fmtcheck generate
@TF_RELEASE=1 sh -c "'$(CURDIR)/scripts/build.sh'"
2015-01-27 03:19:22 +01:00
# dev creates binaries for testing Terraform locally. These are put
# into ./bin/ as well as $GOPATH/bin
dev: fmtcheck generate
@TF_DEV=1 sh -c "'$(CURDIR)/scripts/build.sh'"
2014-07-28 19:53:36 +02:00
quickdev: generate
@TF_DEV=1 sh -c "'$(CURDIR)/scripts/build.sh'"
# Shorthand for building and installing just one plugin for local testing.
# Run as (for example): make plugin-dev PLUGIN=provider-aws
plugin-dev: generate
go install github.com/hashicorp/terraform/builtin/bins/$(PLUGIN)
mv $(GOPATH)/bin/$(PLUGIN) $(GOPATH)/bin/terraform-$(PLUGIN)
# test runs the unit tests
# we run this one package at a time here because running the entire suite in
# one command creates memory usage issues when running in Travis-CI.
test: fmtcheck generate
go test -i $(TEST) || exit 1
go list $(TEST) | xargs -t -n4 go test $(TESTARGS) -timeout=60s -parallel=4
2014-05-23 01:56:28 +02:00
2015-01-27 03:19:22 +01:00
# testacc runs acceptance tests
testacc: fmtcheck generate
@if [ "$(TEST)" = "./..." ]; then \
echo "ERROR: Set TEST to a specific package. For example,"; \
2015-05-29 19:56:15 +02:00
echo " make testacc TEST=./builtin/providers/aws"; \
exit 1; \
fi
TF_ACC=1 go test $(TEST) -v $(TESTARGS) -timeout 120m
# e2etest runs the end-to-end tests against a generated Terraform binary
# The TF_ACC here allows network access, but does not require any special
# credentials since the e2etests use local-only providers such as "null".
e2etest: generate
TF_ACC=1 go test -v ./command/e2etest
test-compile: fmtcheck generate
@if [ "$(TEST)" = "./..." ]; then \
echo "ERROR: Set TEST to a specific package. For example,"; \
echo " make test-compile TEST=./builtin/providers/aws"; \
exit 1; \
fi
go test -c $(TEST) $(TESTARGS)
2015-01-27 03:19:22 +01:00
# testrace runs the race checker
testrace: fmtcheck generate
TF_ACC= go test -race $(TEST) $(TESTARGS)
2014-06-26 19:33:39 +02:00
2015-02-16 18:58:17 +01:00
cover:
@go tool cover 2>/dev/null; if [ $$? -eq 3 ]; then \
go get -u golang.org/x/tools/cmd/cover; \
fi
go test $(TEST) -coverprofile=coverage.out
go tool cover -html=coverage.out
2015-02-16 18:58:17 +01:00
rm coverage.out
2015-01-27 03:19:22 +01:00
# vet runs the Go source code static analysis tool `vet` to find
# any common errors.
Makefile: add vet target Add a vet target in order to catch suspicious constructs reported by go vet. Vet has successfully detected problems in the past, for example, see 482460c4c8a663ec2882bbddbb32da8e990de080 fc36b1cd9490233a3d220365fac3bc65679fe6de 68a41035a92606b6943c517fd874b54e8237485f 7b704fb77d6430cde07703f7cc8574484630d85c 4f3f85b1651d0c34c27c79cdbb772ecc07d6665a 95fa353ee928a42de1923d0f961e40d4ce201443 4bfe18b40d0749c073b3c4ba23f5c908436815d0 Some vet flags are noisy. In particular, the following flags reports a large amount of generally unharmful constructs: -assign: check for useless assignments -composites: check that composite literals used field-keyed elements -shadow: check for shadowed variables -shadowstrict: whether to be strict about shadowing -unreachable: check for unreachable code In order to skip running the flags mentioned above, vet is invoked on a directory basis with 'go tool vet .' since package- level type-checking with 'go vet' doesn't accept flags. Hence, each file is vetted in isolation, which is weaker than package-level type-checking. But nevertheless, it might catch suspicious constructs that pose a real problem. The vet target runs the following flags on the entire repo: -asmdecl: check assembly against Go declarations -atomic: check for common mistaken usages of the sync/atomic package -bool: check for mistakes involving boolean operators -buildtags: check that +build tags are valid -copylocks: check that locks are not passed by value -methods: check that canonically named methods are canonically defined -nilfunc: check for comparisons between functions and nil -printf: check printf-like invocations -rangeloops: check that range loop variables are used correctly -shift: check for useless shifts -structtags: check that struct field tags have canonical format and apply to exported fields as needed -unsafeptr: check for misuse of unsafe.Pointer Now and then, it might make sense to check the output of VETARGS=-unreachable make vet manually, just in case it detects several lines of dead code etc.
2015-01-16 22:20:32 +01:00
vet:
@echo 'go vet ./...'
@go vet ./... ; if [ $$? -eq 1 ]; then \
Makefile: add vet target Add a vet target in order to catch suspicious constructs reported by go vet. Vet has successfully detected problems in the past, for example, see 482460c4c8a663ec2882bbddbb32da8e990de080 fc36b1cd9490233a3d220365fac3bc65679fe6de 68a41035a92606b6943c517fd874b54e8237485f 7b704fb77d6430cde07703f7cc8574484630d85c 4f3f85b1651d0c34c27c79cdbb772ecc07d6665a 95fa353ee928a42de1923d0f961e40d4ce201443 4bfe18b40d0749c073b3c4ba23f5c908436815d0 Some vet flags are noisy. In particular, the following flags reports a large amount of generally unharmful constructs: -assign: check for useless assignments -composites: check that composite literals used field-keyed elements -shadow: check for shadowed variables -shadowstrict: whether to be strict about shadowing -unreachable: check for unreachable code In order to skip running the flags mentioned above, vet is invoked on a directory basis with 'go tool vet .' since package- level type-checking with 'go vet' doesn't accept flags. Hence, each file is vetted in isolation, which is weaker than package-level type-checking. But nevertheless, it might catch suspicious constructs that pose a real problem. The vet target runs the following flags on the entire repo: -asmdecl: check assembly against Go declarations -atomic: check for common mistaken usages of the sync/atomic package -bool: check for mistakes involving boolean operators -buildtags: check that +build tags are valid -copylocks: check that locks are not passed by value -methods: check that canonically named methods are canonically defined -nilfunc: check for comparisons between functions and nil -printf: check printf-like invocations -rangeloops: check that range loop variables are used correctly -shift: check for useless shifts -structtags: check that struct field tags have canonical format and apply to exported fields as needed -unsafeptr: check for misuse of unsafe.Pointer Now and then, it might make sense to check the output of VETARGS=-unreachable make vet manually, just in case it detects several lines of dead code etc.
2015-01-16 22:20:32 +01:00
echo ""; \
echo "Vet found suspicious constructs. Please check the reported constructs"; \
echo "and fix them if necessary before submitting the code for review."; \
2015-05-30 19:52:24 +02:00
exit 1; \
Makefile: add vet target Add a vet target in order to catch suspicious constructs reported by go vet. Vet has successfully detected problems in the past, for example, see 482460c4c8a663ec2882bbddbb32da8e990de080 fc36b1cd9490233a3d220365fac3bc65679fe6de 68a41035a92606b6943c517fd874b54e8237485f 7b704fb77d6430cde07703f7cc8574484630d85c 4f3f85b1651d0c34c27c79cdbb772ecc07d6665a 95fa353ee928a42de1923d0f961e40d4ce201443 4bfe18b40d0749c073b3c4ba23f5c908436815d0 Some vet flags are noisy. In particular, the following flags reports a large amount of generally unharmful constructs: -assign: check for useless assignments -composites: check that composite literals used field-keyed elements -shadow: check for shadowed variables -shadowstrict: whether to be strict about shadowing -unreachable: check for unreachable code In order to skip running the flags mentioned above, vet is invoked on a directory basis with 'go tool vet .' since package- level type-checking with 'go vet' doesn't accept flags. Hence, each file is vetted in isolation, which is weaker than package-level type-checking. But nevertheless, it might catch suspicious constructs that pose a real problem. The vet target runs the following flags on the entire repo: -asmdecl: check assembly against Go declarations -atomic: check for common mistaken usages of the sync/atomic package -bool: check for mistakes involving boolean operators -buildtags: check that +build tags are valid -copylocks: check that locks are not passed by value -methods: check that canonically named methods are canonically defined -nilfunc: check for comparisons between functions and nil -printf: check printf-like invocations -rangeloops: check that range loop variables are used correctly -shift: check for useless shifts -structtags: check that struct field tags have canonical format and apply to exported fields as needed -unsafeptr: check for misuse of unsafe.Pointer Now and then, it might make sense to check the output of VETARGS=-unreachable make vet manually, just in case it detects several lines of dead code etc.
2015-01-16 22:20:32 +01:00
fi
2015-01-27 03:19:22 +01:00
# generate runs `go generate` to build the dynamically generated
# source files.
generate:
@which stringer > /dev/null; if [ $$? -ne 0 ]; then \
go get -u golang.org/x/tools/cmd/stringer; \
fi
go generate ./...
@go fmt command/internal_plugin_list.go > /dev/null
fmt:
gofmt -w $(GOFMT_FILES)
fmtcheck:
@sh -c "'$(CURDIR)/scripts/gofmtcheck.sh'"
vendor-status:
@govendor status
2017-02-18 00:31:20 +01:00
# disallow any parallelism (-j) for Make. This is necessary since some
# commands during the build process create temporary files that collide
# under parallel conditions.
.NOTPARALLEL:
.PHONY: bin cover default dev e2etest fmt fmtcheck generate plugin-dev quickdev test-compile test testacc testrace tools vendor-status vet